#include <propeller.h>
#include "calc.h"

extern inline int32_t Between__(int32_t x, int32_t a, int32_t b){ if (a <= b) return x >= a && x <= b; return x >= b && x <= a; }

#define Lookup__(x, b, a, n) __extension__({ int32_t i = (x)-(b); ((unsigned)i >= n) ? 0 : (a)[i]; })

int32_t calcSpin::Main(void)
{
  int32_t result = 0;
  int32_t	Touchtest;
  Tch.Beginprogram();
  Calculator();
  Tch.Setwarmboot();
  return result;
}

int32_t calcSpin::Calculator(void)
{
  int32_t result = 0;
  int32_t	Xval, Yval, Address, Ascii, Operand, Font, A, B, Answer;
  Tch.Clearscreen(0);
  Tch.Clearram();
  Tch.Sdbmptoram((int32_t)"calcpic.bmp");
  Tch.Drawbmpram(2, 0, 0);
  Font = Tch.Loadfont((int32_t)"DSdig.ifn");
  Tch.Stringdim(10);
  Tch.Stringclear(0);
  Tch.Selectspigroup();
  while (1) {
    Yval = Tch.Touchypercent();
    Xval = Tch.Touchxpercent();
    if ((Xval != 255) && (Yval != 255)) {
      Tch.Selectmemgroup();
      Address = 1;
      int32_t _tmp__0058 = ((Yval * 32) / 10);
      if (Between__(_tmp__0058, 60, 101)) {
        Address = 0;
      } else if (Between__(_tmp__0058, 104, 140)) {
        Address = 4;
      } else if (Between__(_tmp__0058, 146, 183)) {
        Address = 8;
      } else if (Between__(_tmp__0058, 187, 222)) {
        Address = 12;
      } else if (Between__(_tmp__0058, 228, 265)) {
        Address = 16;
      } else if (Between__(_tmp__0058, 271, 307)) {
        Address = 20;
      }
      int32_t _tmp__0059 = ((Xval * 24) / 10);
      if (Between__(_tmp__0059, 0, 66)) {
        Address = (Address + 0);
      } else if (Between__(_tmp__0059, 67, 119)) {
        Address = (Address + 1);
      } else if (Between__(_tmp__0059, 120, 172)) {
        Address = (Address + 2);
      } else if (Between__(_tmp__0059, 173, 239)) {
        Address = (Address + 3);
      }
      Ascii = Lookup__(Address, 0, ((int32_t[]){'X', 'Q', 'Q', 'Q', 'C', 8, '/', '*', '7', '8', '9', '-', '4', '5', '6', '+', '1', '2', '3', '=', '0', '0', '.', '=', }), 24);
      if (Ascii == 'X') {
        return result;
      } else if (Ascii == 'C') {
        Tch.Stringclear(0);
        Calcclear();
      } else if (Between__(Ascii, '0', '9')) {
        Tch.Stringaddchar(0, Ascii);
        Calcclear();
        Tch.Stringprint(Font, 0);
      } else if (Ascii == '+' || Ascii == '-' || Ascii == '*' || Ascii == '/') {
        Tch.Stringcopy(1, 0);
        Tch.Stringaddchar(0, Ascii);
        Calcclear();
        Tch.Stringprint(Font, 0);
        Tch.Stringclear(0);
        Operand = Ascii;
      } else if (Ascii == '=') {
        A = Tch.Stringval(1);
        B = Tch.Stringval(0);
        if (Operand == '+') {
          Answer = (A + B);
        } else if (Operand == '-') {
          Answer = (A - B);
        } else if (Operand == '*') {
          Answer = (A * B);
        } else if (Operand == '/') {
          Answer = (A / B);
        }
        Tch.Stringstr(2, Answer);
        Calcclear();
        Tch.Stringprint(Font, 2);
      }
      Tch.Selectspigroup();
      Tch.Pause1ms(250);
    }
  }
  return result;
}

int32_t calcSpin::Calcclear(void)
{
  int32_t result = 0;
  Tch.Clearrectangle(25, 21, 220, 48, Tch.Getbackfontcolor());
  Tch.Setcursor(25, 15);
  return result;
}


calcSpin MainObj__;

int main() {
  return MainObj__.Main();
}
